]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: set mail host in emacs_deliver
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 #
4 # This program is free software: you can redistribute it and/or modify
5 # it under the terms of the GNU General Public License as published by
6 # the Free Software Foundation, either version 2 of the License, or
7 # (at your option) any later version.
8 #
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
12 # GNU General Public License for more details.
13 #
14 # You should have received a copy of the GNU General Public License
15 # along with this program.  If not, see http://www.gnu.org/licenses/ .
16
17 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
18     echo "Error: The notmuch test suite requires a bash version >= 4.0"
19     echo "due to use of associative arrays within the test suite."
20     echo "Please try again with a newer bash (or help us fix the"
21     echo "test suite to be more portable). Thanks."
22     exit 1
23 fi
24
25 # Make sure echo builtin does not expand backslash-escape sequences by default.
26 shopt -u xpg_echo
27
28 # if --tee was passed, write the output not only to the terminal, but
29 # additionally to the file test-results/$BASENAME.out, too.
30 case "$GIT_TEST_TEE_STARTED, $* " in
31 done,*)
32         # do not redirect again
33         ;;
34 *' --tee '*|*' --va'*)
35         mkdir -p test-results
36         BASE=test-results/$(basename "$0" .sh)
37         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
38          echo $? > $BASE.exit) | tee $BASE.out
39         test "$(cat $BASE.exit)" = 0
40         exit
41         ;;
42 esac
43
44 # Keep the original TERM for say_color and test_emacs
45 ORIGINAL_TERM=$TERM
46
47 # dtach(1) provides more capable terminal environment to anything
48 # that requires more than dumb terminal...
49 [ x"${TERM:-dumb}" = xdumb ] && DTACH_TERM=vt100 || DTACH_TERM=$TERM
50
51 # For repeatability, reset the environment to known value.
52 LANG=C
53 LC_ALL=C
54 PAGER=cat
55 TZ=UTC
56 TERM=dumb
57 export LANG LC_ALL PAGER TERM TZ
58 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
59 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
60       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
61     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
62     exit 1
63 fi
64 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
65 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
66
67 # Protect ourselves from common misconfiguration to export
68 # CDPATH into the environment
69 unset CDPATH
70
71 unset GREP_OPTIONS
72
73 # Convenience
74 #
75 # A regexp to match 5 and 40 hexdigits
76 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
77 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
78
79 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
80 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
81
82 # Each test should start with something like this, after copyright notices:
83 #
84 # test_description='Description of this test...
85 # This test checks if command xyzzy does the right thing...
86 # '
87 # . ./test-lib.sh
88 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
89                 TERM=$ORIGINAL_TERM &&
90                 export TERM &&
91                 [ -t 1 ] &&
92                 tput bold >/dev/null 2>&1 &&
93                 tput setaf 1 >/dev/null 2>&1 &&
94                 tput sgr0 >/dev/null 2>&1
95         ) &&
96         color=t
97
98 while test "$#" -ne 0
99 do
100         case "$1" in
101         -d|--d|--de|--deb|--debu|--debug)
102                 debug=t; shift ;;
103         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
104                 immediate=t; shift ;;
105         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
106                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
107         -h|--h|--he|--hel|--help)
108                 help=t; shift ;;
109         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
110                 verbose=t; shift ;;
111         -q|--q|--qu|--qui|--quie|--quiet)
112                 quiet=t; shift ;;
113         --with-dashes)
114                 with_dashes=t; shift ;;
115         --no-color)
116                 color=; shift ;;
117         --no-python)
118                 # noop now...
119                 shift ;;
120         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
121                 valgrind=t; verbose=t; shift ;;
122         --tee)
123                 shift ;; # was handled already
124         --root=*)
125                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
126                 shift ;;
127         *)
128                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
129         esac
130 done
131
132 if test -n "$debug"; then
133     print_subtest () {
134         printf " %-4s" "[$((test_count - 1))]"
135     }
136 else
137     print_subtest () {
138         true
139     }
140 fi
141
142 if test -n "$color"; then
143         say_color () {
144                 (
145                 TERM=$ORIGINAL_TERM
146                 export TERM
147                 case "$1" in
148                         error) tput bold; tput setaf 1;; # bold red
149                         skip)  tput bold; tput setaf 2;; # bold green
150                         pass)  tput setaf 2;;            # green
151                         info)  tput setaf 3;;            # brown
152                         *) test -n "$quiet" && return;;
153                 esac
154                 shift
155                 printf " "
156                 printf "$@"
157                 tput sgr0
158                 print_subtest
159                 )
160         }
161 else
162         say_color() {
163                 test -z "$1" && test -n "$quiet" && return
164                 shift
165                 printf " "
166                 printf "$@"
167                 print_subtest
168         }
169 fi
170
171 error () {
172         say_color error "error: $*\n"
173         GIT_EXIT_OK=t
174         exit 1
175 }
176
177 say () {
178         say_color info "$*"
179 }
180
181 test "${test_description}" != "" ||
182 error "Test script did not set test_description."
183
184 if test "$help" = "t"
185 then
186         echo "Tests ${test_description}"
187         exit 0
188 fi
189
190 echo $(basename "$0"): "Testing ${test_description}"
191
192 exec 5>&1
193
194 test_failure=0
195 test_count=0
196 test_fixed=0
197 test_broken=0
198 test_success=0
199
200 _die_common () {
201         code=$?
202         trap - EXIT
203         set +ex
204         rm -rf "$TEST_TMPDIR"
205 }
206
207 die () {
208         _die_common
209         if test -n "$GIT_EXIT_OK"
210         then
211                 exit $code
212         else
213                 exec >&5
214                 say_color error '%-6s' FATAL
215                 echo " $test_subtest_name"
216                 echo
217                 echo "Unexpected exit while executing $0. Exit code $code."
218                 exit 1
219         fi
220 }
221
222 die_signal () {
223         _die_common
224         echo >&5 "FATAL: $0: interrupted by signal" $((code - 128))
225         exit $code
226 }
227
228 GIT_EXIT_OK=
229 # Note: TEST_TMPDIR *NOT* exported!
230 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
231 trap 'die' EXIT
232 trap 'die_signal' HUP INT TERM
233
234 test_decode_color () {
235         sed     -e 's/.\[1m/<WHITE>/g' \
236                 -e 's/.\[31m/<RED>/g' \
237                 -e 's/.\[32m/<GREEN>/g' \
238                 -e 's/.\[33m/<YELLOW>/g' \
239                 -e 's/.\[34m/<BLUE>/g' \
240                 -e 's/.\[35m/<MAGENTA>/g' \
241                 -e 's/.\[36m/<CYAN>/g' \
242                 -e 's/.\[m/<RESET>/g'
243 }
244
245 q_to_nul () {
246         perl -pe 'y/Q/\000/'
247 }
248
249 q_to_cr () {
250         tr Q '\015'
251 }
252
253 append_cr () {
254         sed -e 's/$/Q/' | tr Q '\015'
255 }
256
257 remove_cr () {
258         tr '\015' Q | sed -e 's/Q$//'
259 }
260
261 # Generate a new message in the mail directory, with a unique message
262 # ID and subject. The message is not added to the index.
263 #
264 # After this function returns, the filename of the generated message
265 # is available as $gen_msg_filename and the message ID is available as
266 # $gen_msg_id .
267 #
268 # This function supports named parameters with the bash syntax for
269 # assigning a value to an associative array ([name]=value). The
270 # supported parameters are:
271 #
272 #  [dir]=directory/of/choice
273 #
274 #       Generate the message in directory 'directory/of/choice' within
275 #       the mail store. The directory will be created if necessary.
276 #
277 #  [filename]=name
278 #
279 #       Store the message in file 'name'. The default is to store it
280 #       in 'msg-<count>', where <count> is three-digit number of the
281 #       message.
282 #
283 #  [body]=text
284 #
285 #       Text to use as the body of the email message
286 #
287 #  '[from]="Some User <user@example.com>"'
288 #  '[to]="Some User <user@example.com>"'
289 #  '[subject]="Subject of email message"'
290 #  '[date]="RFC 822 Date"'
291 #
292 #       Values for email headers. If not provided, default values will
293 #       be generated instead.
294 #
295 #  '[cc]="Some User <user@example.com>"'
296 #  [reply-to]=some-address
297 #  [in-reply-to]=<message-id>
298 #  [references]=<message-id>
299 #  [content-type]=content-type-specification
300 #  '[header]=full header line, including keyword'
301 #
302 #       Additional values for email headers. If these are not provided
303 #       then the relevant headers will simply not appear in the
304 #       message.
305 #
306 #  '[id]=message-id'
307 #
308 #       Controls the message-id of the created message.
309 gen_msg_cnt=0
310 gen_msg_filename=""
311 gen_msg_id=""
312 generate_message ()
313 {
314     # This is our (bash-specific) magic for doing named parameters
315     local -A template="($@)"
316     local additional_headers
317
318     gen_msg_cnt=$((gen_msg_cnt + 1))
319     if [ -z "${template[filename]}" ]; then
320         gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
321     else
322         gen_msg_name=${template[filename]}
323     fi
324
325     if [ -z "${template[id]}" ]; then
326         gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
327     else
328         gen_msg_id="${template[id]}"
329     fi
330
331     if [ -z "${template[dir]}" ]; then
332         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
333     else
334         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
335         mkdir -p "$(dirname "$gen_msg_filename")"
336     fi
337
338     if [ -z "${template[body]}" ]; then
339         template[body]="This is just a test message (#${gen_msg_cnt})"
340     fi
341
342     if [ -z "${template[from]}" ]; then
343         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
344     fi
345
346     if [ -z "${template[to]}" ]; then
347         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
348     fi
349
350     if [ -z "${template[subject]}" ]; then
351         if [ -n "$test_subtest_name" ]; then
352             template[subject]="$test_subtest_name"
353         else
354             template[subject]="Test message #${gen_msg_cnt}"
355         fi
356     fi
357
358     if [ -z "${template[date]}" ]; then
359         template[date]="Fri, 05 Jan 2001 15:43:57 +0000"
360     fi
361
362     additional_headers=""
363     if [ ! -z "${template[header]}" ]; then
364         additional_headers="${template[header]}
365 ${additional_headers}"
366     fi
367
368     if [ ! -z "${template[reply-to]}" ]; then
369         additional_headers="Reply-To: ${template[reply-to]}
370 ${additional_headers}"
371     fi
372
373     if [ ! -z "${template[in-reply-to]}" ]; then
374         additional_headers="In-Reply-To: ${template[in-reply-to]}
375 ${additional_headers}"
376     fi
377
378     if [ ! -z "${template[cc]}" ]; then
379         additional_headers="Cc: ${template[cc]}
380 ${additional_headers}"
381     fi
382
383     if [ ! -z "${template[bcc]}" ]; then
384         additional_headers="Bcc: ${template[bcc]}
385 ${additional_headers}"
386     fi
387
388     if [ ! -z "${template[references]}" ]; then
389         additional_headers="References: ${template[references]}
390 ${additional_headers}"
391     fi
392
393     if [ ! -z "${template[content-type]}" ]; then
394         additional_headers="Content-Type: ${template[content-type]}
395 ${additional_headers}"
396     fi
397
398     if [ ! -z "${template[content-transfer-encoding]}" ]; then
399         additional_headers="Content-Transfer-Encoding: ${template[content-transfer-encoding]}
400 ${additional_headers}"
401     fi
402
403     # Note that in the way we're setting it above and using it below,
404     # `additional_headers' will also serve as the header / body separator
405     # (empty line in between).
406
407     cat <<EOF >"$gen_msg_filename"
408 From: ${template[from]}
409 To: ${template[to]}
410 Message-Id: <${gen_msg_id}>
411 Subject: ${template[subject]}
412 Date: ${template[date]}
413 ${additional_headers}
414 ${template[body]}
415 EOF
416 }
417
418 # Generate a new message and add it to the database.
419 #
420 # All of the arguments and return values supported by generate_message
421 # are also supported here, so see that function for details.
422 add_message ()
423 {
424     generate_message "$@" &&
425     notmuch new > /dev/null
426 }
427
428 # Deliver a message with emacs and add it to the database
429 #
430 # Uses emacs to generate and deliver a message to the mail store.
431 # Accepts arbitrary extra emacs/elisp functions to modify the message
432 # before sending, which is useful to doing things like attaching files
433 # to the message and encrypting/signing.
434 emacs_deliver_message ()
435 {
436     local subject="$1"
437     local body="$2"
438     shift 2
439     # before we can send a message, we have to prepare the FCC maildir
440     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
441     # eval'ing smtp-dummy --background will set smtp_dummy_pid
442     smtp_dummy_pid=
443     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
444     test -n "$smtp_dummy_pid" || return 1
445
446     test_emacs \
447         "(let ((message-send-mail-function 'message-smtpmail-send-it)
448                (mail-host-address \"example.com\")
449                (smtpmail-smtp-server \"localhost\")
450                (smtpmail-smtp-service \"25025\"))
451            (notmuch-hello)
452            (notmuch-mua-mail)
453            (message-goto-to)
454            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
455            (message-goto-subject)
456            (insert \"${subject}\")
457            (message-goto-body)
458            (insert \"${body}\")
459            $@
460            (message-send-and-exit))"
461
462     # In case message was sent properly, client waits for confirmation
463     # before exiting and resuming control here; therefore making sure
464     # that server exits by sending (KILL) signal to it is safe.
465     kill -9 $smtp_dummy_pid
466     notmuch new >/dev/null
467 }
468
469 # Generate a corpus of email and add it to the database.
470 #
471 # This corpus is fixed, (it happens to be 50 messages from early in
472 # the history of the notmuch mailing list), which allows for reliably
473 # testing commands that need to operate on a not-totally-trivial
474 # number of messages.
475 add_email_corpus ()
476 {
477     rm -rf ${MAIL_DIR}
478     if [ -d $TEST_DIRECTORY/corpus.mail ]; then
479         cp -a $TEST_DIRECTORY/corpus.mail ${MAIL_DIR}
480     else
481         cp -a $TEST_DIRECTORY/corpus ${MAIL_DIR}
482         notmuch new >/dev/null
483         cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpus.mail
484     fi
485 }
486
487 test_begin_subtest ()
488 {
489     if [ -n "$inside_subtest" ]; then
490         exec 1>&6 2>&7          # Restore stdout and stderr
491         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
492     fi
493     test_subtest_name="$1"
494     test_reset_state_
495     # Remember stdout and stderr file descriptors and redirect test
496     # output to the previously prepared file descriptors 3 and 4 (see
497     # below)
498     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
499     exec 6>&1 7>&2 >&3 2>&4
500     inside_subtest=t
501 }
502
503 # Pass test if two arguments match
504 #
505 # Note: Unlike all other test_expect_* functions, this function does
506 # not accept a test name. Instead, the caller should call
507 # test_begin_subtest before calling this function in order to set the
508 # name.
509 test_expect_equal ()
510 {
511         exec 1>&6 2>&7          # Restore stdout and stderr
512         inside_subtest=
513         test "$#" = 3 && { prereq=$1; shift; } || prereq=
514         test "$#" = 2 ||
515         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
516
517         output="$1"
518         expected="$2"
519         if ! test_skip "$test_subtest_name"
520         then
521                 if [ "$output" = "$expected" ]; then
522                         test_ok_
523                 else
524                         testname=$this_test.$test_count
525                         echo "$expected" > $testname.expected
526                         echo "$output" > $testname.output
527                         test_failure_ "$(diff -u $testname.expected $testname.output)"
528                 fi
529     fi
530 }
531
532 # Like test_expect_equal, but takes two filenames.
533 test_expect_equal_file ()
534 {
535         exec 1>&6 2>&7          # Restore stdout and stderr
536         inside_subtest=
537         test "$#" = 3 && { prereq=$1; shift; } || prereq=
538         test "$#" = 2 ||
539         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
540
541         file1="$1"
542         basename1=`basename "$file1"`
543         file2="$2"
544         basename2=`basename "$file2"`
545         if ! test_skip "$test_subtest_name"
546         then
547                 if diff -q "$file1" "$file2" >/dev/null ; then
548                         test_ok_
549                 else
550                         testname=$this_test.$test_count
551                         cp "$file1" "$testname.$basename1"
552                         cp "$file2" "$testname.$basename2"
553                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
554                 fi
555     fi
556 }
557
558 # Like test_expect_equal, but arguments are JSON expressions to be
559 # canonicalized before diff'ing.  If an argument cannot be parsed, it
560 # is used unchanged so that there's something to diff against.
561 test_expect_equal_json () {
562     # The test suite forces LC_ALL=C, but this causes Python 3 to
563     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
564     # override Python's stdio encoding defaults.
565     output=$(echo "$1" | PYTHONIOENCODING=utf-8 python -mjson.tool \
566         || echo "$1")
567     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 python -mjson.tool \
568         || echo "$2")
569     shift 2
570     test_expect_equal "$output" "$expected" "$@"
571 }
572
573 test_emacs_expect_t () {
574         test "$#" = 2 && { prereq=$1; shift; } || prereq=
575         test "$#" = 1 ||
576         error "bug in the test script: not 1 or 2 parameters to test_emacs_expect_t"
577
578         # Run the test.
579         if ! test_skip "$test_subtest_name"
580         then
581                 test_emacs "(notmuch-test-run $1)" >/dev/null
582
583                 # Restore state after the test.
584                 exec 1>&6 2>&7          # Restore stdout and stderr
585                 inside_subtest=
586
587                 # Report success/failure.
588                 result=$(cat OUTPUT)
589                 if [ "$result" = t ]
590                 then
591                         test_ok_
592                 else
593                         test_failure_ "${result}"
594                 fi
595         else
596                 # Restore state after the (non) test.
597                 exec 1>&6 2>&7          # Restore stdout and stderr
598                 inside_subtest=
599         fi
600 }
601
602 NOTMUCH_NEW ()
603 {
604     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
605 }
606
607 notmuch_search_sanitize ()
608 {
609     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
610 }
611
612 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
613 notmuch_show_sanitize ()
614 {
615     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
616 }
617 notmuch_show_sanitize_all ()
618 {
619     sed \
620         -e 's| filename:.*| filename:XXXXX|' \
621         -e 's| id:[^ ]* | id:XXXXX |'
622 }
623
624 notmuch_json_show_sanitize ()
625 {
626     sed \
627         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
628         -e 's|"filename": "/[^"]*",|"filename": "YYYYY",|g'
629 }
630
631 # End of notmuch helper functions
632
633 # Use test_set_prereq to tell that a particular prerequisite is available.
634 # The prerequisite can later be checked for in two ways:
635 #
636 # - Explicitly using test_have_prereq.
637 #
638 # - Implicitly by specifying the prerequisite tag in the calls to
639 #   test_expect_{success,failure,code}.
640 #
641 # The single parameter is the prerequisite tag (a simple word, in all
642 # capital letters by convention).
643
644 test_set_prereq () {
645         satisfied="$satisfied$1 "
646 }
647 satisfied=" "
648
649 test_have_prereq () {
650         case $satisfied in
651         *" $1 "*)
652                 : yes, have it ;;
653         *)
654                 ! : nope ;;
655         esac
656 }
657
658 declare -A test_missing_external_prereq_
659 declare -A test_subtest_missing_external_prereq_
660
661 # declare prerequisite for the given external binary
662 test_declare_external_prereq () {
663         binary="$1"
664         test "$#" = 2 && name=$2 || name="$binary(1)"
665
666         if ! hash $binary 2>/dev/null; then
667                 test_missing_external_prereq_["${binary}"]=t
668                 eval "
669 $binary () {
670         test_subtest_missing_external_prereq_[\"${name}\"]=t
671         false
672 }"
673         fi
674 }
675
676 # Explicitly require external prerequisite.  Useful when binary is
677 # called indirectly (e.g. from emacs).
678 # Returns success if dependency is available, failure otherwise.
679 test_require_external_prereq () {
680         binary="$1"
681         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
682                 # dependency is missing, call the replacement function to note it
683                 eval "$binary"
684         else
685                 true
686         fi
687 }
688
689 # You are not expected to call test_ok_ and test_failure_ directly, use
690 # the text_expect_* functions instead.
691
692 test_ok_ () {
693         if test "$test_subtest_known_broken_" = "t"; then
694                 test_known_broken_ok_
695                 return
696         fi
697         test_success=$(($test_success + 1))
698         say_color pass "%-6s" "PASS"
699         echo " $test_subtest_name"
700 }
701
702 test_failure_ () {
703         if test "$test_subtest_known_broken_" = "t"; then
704                 test_known_broken_failure_ "$@"
705                 return
706         fi
707         test_failure=$(($test_failure + 1))
708         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
709         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
710         return 1
711 }
712
713 test_failure_message_ () {
714         say_color error "%-6s" "$1"
715         echo " $2"
716         shift 2
717         echo "$@" | sed -e 's/^/        /'
718         if test "$verbose" != "t"; then cat test.output; fi
719 }
720
721 test_known_broken_ok_ () {
722         test_reset_state_
723         test_fixed=$(($test_fixed+1))
724         say_color pass "%-6s" "FIXED"
725         echo " $test_subtest_name"
726 }
727
728 test_known_broken_failure_ () {
729         test_reset_state_
730         test_broken=$(($test_broken+1))
731         test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
732         return 1
733 }
734
735 test_debug () {
736         test "$debug" = "" || eval "$1"
737 }
738
739 test_run_ () {
740         test_cleanup=:
741         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
742         eval >&3 2>&4 "$1"
743         eval_ret=$?
744         eval >&3 2>&4 "$test_cleanup"
745         return 0
746 }
747
748 test_skip () {
749         test_count=$(($test_count+1))
750         to_skip=
751         for skp in $NOTMUCH_SKIP_TESTS
752         do
753                 case $this_test.$test_count in
754                 $skp)
755                         to_skip=t
756                 esac
757         done
758         if test -z "$to_skip" && test -n "$prereq" &&
759            ! test_have_prereq "$prereq"
760         then
761                 to_skip=t
762         fi
763         case "$to_skip" in
764         t)
765                 test_report_skip_ "$@"
766                 ;;
767         *)
768                 test_check_missing_external_prereqs_ "$@"
769                 ;;
770         esac
771 }
772
773 test_check_missing_external_prereqs_ () {
774         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
775                 say_color skip >&1 "missing prerequisites: "
776                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
777                 test_report_skip_ "$@"
778         else
779                 false
780         fi
781 }
782
783 test_report_skip_ () {
784         test_reset_state_
785         say_color skip >&3 "skipping test:"
786         echo " $@" >&3
787         say_color skip "%-6s" "SKIP"
788         echo " $1"
789 }
790
791 test_subtest_known_broken () {
792         test_subtest_known_broken_=t
793 }
794
795 test_expect_success () {
796         test "$#" = 3 && { prereq=$1; shift; } || prereq=
797         test "$#" = 2 ||
798         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
799         test_subtest_name="$1"
800         test_reset_state_
801         if ! test_skip "$@"
802         then
803                 test_run_ "$2"
804                 run_ret="$?"
805                 # test_run_ may update missing external prerequisites
806                 test_check_missing_external_prereqs_ "$@" ||
807                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
808                 then
809                         test_ok_
810                 else
811                         test_failure_ "$2"
812                 fi
813         fi
814 }
815
816 test_expect_code () {
817         test "$#" = 4 && { prereq=$1; shift; } || prereq=
818         test "$#" = 3 ||
819         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
820         test_subtest_name="$2"
821         test_reset_state_
822         if ! test_skip "$@"
823         then
824                 test_run_ "$3"
825                 run_ret="$?"
826                 # test_run_ may update missing external prerequisites,
827                 test_check_missing_external_prereqs_ "$@" ||
828                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
829                 then
830                         test_ok_
831                 else
832                         test_failure_ "exit code $eval_ret, expected $1" "$3"
833                 fi
834         fi
835 }
836
837 # test_external runs external test scripts that provide continuous
838 # test output about their progress, and succeeds/fails on
839 # zero/non-zero exit code.  It outputs the test output on stdout even
840 # in non-verbose mode, and announces the external script with "* run
841 # <n>: ..." before running it.  When providing relative paths, keep in
842 # mind that all scripts run in "trash directory".
843 # Usage: test_external description command arguments...
844 # Example: test_external 'Perl API' perl ../path/to/test.pl
845 test_external () {
846         test "$#" = 4 && { prereq=$1; shift; } || prereq=
847         test "$#" = 3 ||
848         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
849         test_subtest_name="$1"
850         shift
851         test_reset_state_
852         if ! test_skip "$test_subtest_name" "$@"
853         then
854                 # Announce the script to reduce confusion about the
855                 # test output that follows.
856                 say_color "" " run $test_count: $descr ($*)"
857                 # Run command; redirect its stderr to &4 as in
858                 # test_run_, but keep its stdout on our stdout even in
859                 # non-verbose mode.
860                 "$@" 2>&4
861                 if [ "$?" = 0 ]
862                 then
863                         test_ok_
864                 else
865                         test_failure_ "$@"
866                 fi
867         fi
868 }
869
870 # Like test_external, but in addition tests that the command generated
871 # no output on stderr.
872 test_external_without_stderr () {
873         # The temporary file has no (and must have no) security
874         # implications.
875         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
876         stderr="$tmp/git-external-stderr.$$.tmp"
877         test_external "$@" 4> "$stderr"
878         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
879         test_subtest_name="no stderr: $1"
880         shift
881         if [ ! -s "$stderr" ]; then
882                 rm "$stderr"
883                 test_ok_
884         else
885                 if [ "$verbose" = t ]; then
886                         output=`echo; echo Stderr is:; cat "$stderr"`
887                 else
888                         output=
889                 fi
890                 # rm first in case test_failure exits.
891                 rm "$stderr"
892                 test_failure_ "$@" "$output"
893         fi
894 }
895
896 # This is not among top-level (test_expect_success)
897 # but is a prefix that can be used in the test script, like:
898 #
899 #       test_expect_success 'complain and die' '
900 #           do something &&
901 #           do something else &&
902 #           test_must_fail git checkout ../outerspace
903 #       '
904 #
905 # Writing this as "! git checkout ../outerspace" is wrong, because
906 # the failure could be due to a segv.  We want a controlled failure.
907
908 test_must_fail () {
909         "$@"
910         test $? -gt 0 -a $? -le 129 -o $? -gt 192
911 }
912
913 # test_cmp is a helper function to compare actual and expected output.
914 # You can use it like:
915 #
916 #       test_expect_success 'foo works' '
917 #               echo expected >expected &&
918 #               foo >actual &&
919 #               test_cmp expected actual
920 #       '
921 #
922 # This could be written as either "cmp" or "diff -u", but:
923 # - cmp's output is not nearly as easy to read as diff -u
924 # - not all diff versions understand "-u"
925
926 test_cmp() {
927         $GIT_TEST_CMP "$@"
928 }
929
930 # This function can be used to schedule some commands to be run
931 # unconditionally at the end of the test to restore sanity:
932 #
933 #       test_expect_success 'test core.capslock' '
934 #               git config core.capslock true &&
935 #               test_when_finished "git config --unset core.capslock" &&
936 #               hello world
937 #       '
938 #
939 # That would be roughly equivalent to
940 #
941 #       test_expect_success 'test core.capslock' '
942 #               git config core.capslock true &&
943 #               hello world
944 #               git config --unset core.capslock
945 #       '
946 #
947 # except that the greeting and config --unset must both succeed for
948 # the test to pass.
949
950 test_when_finished () {
951         test_cleanup="{ $*
952                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
953 }
954
955 test_done () {
956         GIT_EXIT_OK=t
957         test_results_dir="$TEST_DIRECTORY/test-results"
958         mkdir -p "$test_results_dir"
959         test_results_path="$test_results_dir/${0%.sh}"
960
961         echo "total $test_count" >> $test_results_path
962         echo "success $test_success" >> $test_results_path
963         echo "fixed $test_fixed" >> $test_results_path
964         echo "broken $test_broken" >> $test_results_path
965         echo "failed $test_failure" >> $test_results_path
966         echo "" >> $test_results_path
967
968         echo
969
970         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
971
972         if [ "$test_failure" = "0" ]; then
973             if [ "$test_broken" = "0" ]; then
974                 rm -rf "$remove_tmp"
975             fi
976             exit 0
977         else
978             exit 1
979         fi
980 }
981
982 emacs_generate_script () {
983         # Construct a little test script here for the benefit of the user,
984         # (who can easily run "run_emacs" to get the same emacs environment
985         # for investigating any failures).
986         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
987 #!/bin/sh
988 export PATH=$PATH
989 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
990
991 # Here's what we are using here:
992 #
993 # --no-init-file        Don't load users ~/.emacs
994 #
995 # --no-site-file        Don't load the site-wide startup stuff
996 #
997 # --directory           Ensure that the local elisp sources are found
998 #
999 # --load                Force loading of notmuch.el and test-lib.el
1000
1001 exec ${TEST_EMACS} --no-init-file --no-site-file \
1002         --directory "$TEST_DIRECTORY/../emacs" --load notmuch.el \
1003         --directory "$TEST_DIRECTORY" --load test-lib.el \
1004         "\$@"
1005 EOF
1006         chmod a+x "$TMP_DIRECTORY/run_emacs"
1007 }
1008
1009 test_emacs () {
1010         # test dependencies beforehand to avoid the waiting loop below
1011         missing_dependencies=
1012         test_require_external_prereq dtach || missing_dependencies=1
1013         test_require_external_prereq emacs || missing_dependencies=1
1014         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1015         test -z "$missing_dependencies" || return
1016
1017         if [ -z "$EMACS_SERVER" ]; then
1018                 emacs_tests="$(basename $0).el"
1019                 if [ -f "$TEST_DIRECTORY/$emacs_tests" ]; then
1020                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1021                 else
1022                         load_emacs_tests=
1023                 fi
1024                 server_name="notmuch-test-suite-$$"
1025                 # start a detached session with an emacs server
1026                 # user's TERM (or 'vt100' in case user's TERM is unset, empty
1027                 # or 'dumb') is given to dtach which assumes a minimally
1028                 # VT100-compatible terminal -- and emacs inherits that
1029                 TERM=$DTACH_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1030                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1031                                 --no-window-system \
1032                                 $load_emacs_tests \
1033                                 --eval '(setq server-name \"$server_name\")' \
1034                                 --eval '(server-start)' \
1035                                 --eval '(orphan-watchdog $$)'" || return
1036                 EMACS_SERVER="$server_name"
1037                 # wait until the emacs server is up
1038                 until test_emacs '()' >/dev/null 2>/dev/null; do
1039                         sleep 1
1040                 done
1041         fi
1042
1043         # Clear test-output output file.  Most Emacs tests end with a
1044         # call to (test-output).  If the test code fails with an
1045         # exception before this call, the output file won't get
1046         # updated.  Since we don't want to compare against an output
1047         # file from another test, so start out with an empty file.
1048         rm -f OUTPUT
1049         touch OUTPUT
1050
1051         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(progn $@)"
1052 }
1053
1054 test_python() {
1055         export LD_LIBRARY_PATH=$TEST_DIRECTORY/../lib
1056         export PYTHONPATH=$TEST_DIRECTORY/../bindings/python
1057
1058         # Some distros (e.g. Arch Linux) ship Python 2.* as /usr/bin/python2,
1059         # most others as /usr/bin/python. So first try python2, and fallback to
1060         # python if python2 doesn't exist.
1061         cmd=python2
1062         [[ ${test_missing_external_prereq_[python2]} == t ]] && cmd=python
1063
1064         (echo "import sys; _orig_stdout=sys.stdout; sys.stdout=open('OUTPUT', 'w')"; cat) \
1065                 | $cmd -
1066 }
1067
1068 # Creates a script that counts how much time it is executed and calls
1069 # notmuch.  $notmuch_counter_command is set to the path to the
1070 # generated script.  Use notmuch_counter_value() function to get the
1071 # current counter value.
1072 notmuch_counter_reset () {
1073         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1074         if [ ! -x "$notmuch_counter_command" ]; then
1075                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1076                 cat >"$notmuch_counter_command" <<EOF || return
1077 #!/bin/sh
1078
1079 read count < "$notmuch_counter_state_path"
1080 echo \$((count + 1)) > "$notmuch_counter_state_path"
1081
1082 exec notmuch "\$@"
1083 EOF
1084                 chmod +x "$notmuch_counter_command" || return
1085         fi
1086
1087         echo 0 > "$notmuch_counter_state_path"
1088 }
1089
1090 # Returns the current notmuch counter value.
1091 notmuch_counter_value () {
1092         if [ -r "$notmuch_counter_state_path" ]; then
1093                 read count < "$notmuch_counter_state_path"
1094         else
1095                 count=0
1096         fi
1097         echo $count
1098 }
1099
1100 test_reset_state_ () {
1101         test -z "$test_init_done_" && test_init_
1102
1103         test_subtest_known_broken_=
1104         test_subtest_missing_external_prereq_=()
1105 }
1106
1107 # called once before the first subtest
1108 test_init_ () {
1109         test_init_done_=t
1110
1111         # skip all tests if there were external prerequisites missing during init
1112         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1113 }
1114
1115
1116 . ./test-lib-common.sh
1117
1118 emacs_generate_script
1119
1120
1121 # Use -P to resolve symlinks in our working directory so that the cwd
1122 # in subprocesses like git equals our $PWD (for pathname comparisons).
1123 cd -P "$test" || error "Cannot setup test environment"
1124
1125 if test "$verbose" = "t"
1126 then
1127         exec 4>&2 3>&1
1128 else
1129         exec 4>test.output 3>&4
1130 fi
1131
1132 this_test=${0##*/}
1133 for skp in $NOTMUCH_SKIP_TESTS
1134 do
1135         to_skip=
1136         for skp in $NOTMUCH_SKIP_TESTS
1137         do
1138                 case "$this_test" in
1139                 $skp)
1140                         to_skip=t
1141                 esac
1142         done
1143         case "$to_skip" in
1144         t)
1145                 say_color skip >&3 "skipping test $this_test altogether"
1146                 say_color skip "skip all tests in $this_test"
1147                 test_done
1148         esac
1149 done
1150
1151 # Provide an implementation of the 'yes' utility
1152 yes () {
1153         if test $# = 0
1154         then
1155                 y=y
1156         else
1157                 y="$*"
1158         fi
1159
1160         while echo "$y"
1161         do
1162                 :
1163         done
1164 }
1165
1166 # Fix some commands on Windows
1167 case $(uname -s) in
1168 *MINGW*)
1169         # Windows has its own (incompatible) sort and find
1170         sort () {
1171                 /usr/bin/sort "$@"
1172         }
1173         find () {
1174                 /usr/bin/find "$@"
1175         }
1176         sum () {
1177                 md5sum "$@"
1178         }
1179         # git sees Windows-style pwd
1180         pwd () {
1181                 builtin pwd -W
1182         }
1183         # no POSIX permissions
1184         # backslashes in pathspec are converted to '/'
1185         # exec does not inherit the PID
1186         ;;
1187 *)
1188         test_set_prereq POSIXPERM
1189         test_set_prereq BSLASHPSPEC
1190         test_set_prereq EXECKEEPSPID
1191         ;;
1192 esac
1193
1194 test -z "$NO_PERL" && test_set_prereq PERL
1195 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1196
1197 # test whether the filesystem supports symbolic links
1198 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1199 rm -f y
1200
1201 # declare prerequisites for external binaries used in tests
1202 test_declare_external_prereq dtach
1203 test_declare_external_prereq emacs
1204 test_declare_external_prereq ${TEST_EMACSCLIENT}
1205 test_declare_external_prereq gdb
1206 test_declare_external_prereq gpg
1207 test_declare_external_prereq python
1208 test_declare_external_prereq python2